

#    These procedures are used by all 

global MIDAS_XAIDAAccessClient_Exists
global MIDAS_XAIDAAccessServer_Exists


    proc InsertLog {s} {
        variable LogText
        variable LogCount
        variable LogFlag
        variable ShowLogFlag
        variable JS

        if {$LogFlag == 1 && $ShowLogFlag == 1} {

            incr LogCount
            if {$LogCount == 1000} {EmptyLog}

            set LogText "$s\n[set LogText]"
        } else {
            if {$JS == ""} {append JS "alert(\""}
            append JS "[string map {\" \\" \n \\n} $s]\\n"
        }
        return ""
    }

    proc EmptyLog {} {
        variable LogText
        variable LogCount

        set LogText ""
        set LogCount 0
    }

    proc Alert {s} {
        variable JS

        if {$JS == ""} {append JS "alert(\""}
        append JS "[string map {\" \\" \n \\n} $s]\\n"
    }

    proc Information {s} {
        variable INFO

        set INFO ""
        append INFO "MyWindow=window.open(\"\",\"MyWindow\",\"toolbar=no,menubar=no,status=no,scrollbars=yes\");"
        append INFO "MyWindow.document.write(\"<html><body>\");"
        append INFO "MyWindow.document.write(\"[string map {\" \\" \n <br>} $s]\\n\");"
        append INFO "MyWindow.document.write(\"</body></html>\");"
        append INFO "MyWindow.document.close();"
    }

    proc PrintLog {} {
        variable LogText

     if {[info procs ::DefineMessage] != "::DefineMessage"} {puts "DefineMessage unknown\n"; return}

        ::DefineMessage -c digitizer -l INFORMATION  "$LogText"
    }

    proc Elog {l s} {

     if {[info procs ::DefineMessage] != "::DefineMessage"} {puts "DefineMessage unknown\n"; return}

        ::DefineMessage -c digitizer -l $l  "$s"
    }

