# stats.defn.tcl


for {set i 0} {$i < 64} {incr i} {
set ITEM($i) "$i"
}

set ITEM(0) "Poll"
set ITEM(1) "Data buffers received"
set ITEM(2) "Data buffers ignored #1"
set ITEM(3) "Data buffers ignored #2"
set ITEM(4) "Data received (bytes)"
set ITEM(5) "ADC items"
set ITEM(6) "WAVE items"
set ITEM(7) "SYNC items"
set ITEM(8) "PAUSE items"
set ITEM(9) "RESUME items"
set ITEM(10) "DISC items"
set ITEM(11) "MBS items"
set ITEM(12) "Bad INFO items"
set ITEM(13) "WAVE data"
set ITEM(14) "Bad Data #1"
set ITEM(15) "Bad Data #2"

set ITEM(20) "Merge Poll"
set ITEM(21) "Data items received"
set ITEM(22) "Data items transmitted"
set ITEM(23) "23"
set ITEM(24) "Transmit buffers"
set ITEM(25) "Transmit data (bytes)"
set ITEM(26) "26"
set ITEM(27) "Sync Pulse items"
set ITEM(28) "Pause items skipped"
set ITEM(29) "Resume items skipped"
set ITEM(30) "Total items output"
set ITEM(31) "Input buffer has emptied"
set ITEM(32) "32"
set ITEM(33) "Sync time not as expected"
set ITEM(34) "Sync time > expected"
set ITEM(35) "Sync time < expected"
set ITEM(36) "An input stream buffer is full"
set ITEM(37) "PileUp seen"
set ITEM(38) "Item not histogrammed"
set ITEM(39) "valid ADC items received"
set ITEM(40) "Extended TS items output"
set ITEM(41) "TRACE items output"
set ITEM(42) "No data buffers available"

set ITEM(48) "THigh"
set ITEM(49) "TLow"


#define SEQERR 20           /* No of Data timestamps older than previous */

#define INC 23			/* Histogram increments performed */
#define TXBUFFERS 24		/* As in DataAcq/x2vb */
#define TXTOTALCOUNT 25		/* As in DataAcq/x2vb */
#define NULLEVENTS 26		/* As in DataAcq/x2vb */

#define PARITYERROR 32		/* Number of parity errors seen */
#define UNDEFINEDDATA 12	/* Number of unrecognised items */
#define SYNCERR 33		/* No of SYNC's seen in wrong place */
#define RESUMEERR 34		/* No of RESUME's after timestamp has passed */
#define ALLPAUSED 35		/* All input streams paused at the same time */
#define FULL 36			/* No room in an input stream buffer */
#define PILEUPS 37		/* Number of Pileups seen */
#define NOINC 38		/* Item not histo'ed (pileup, vetoed...) */
#define VALIDADC 39		/* Number of valid ADC items received */
#define EXT_TSS 40		/* Number of Extended Timestamp items output  */
#define TRACES 41		/* Number of TRACE items output */
#define LINKBUF_FREE 42		/* Base link buffers free, link 0 */
