# Note:  This is loaded in the namespace
# variable started 0

if {![info exists started]} {variable started 0 }

if {$started != 0} {
    variable JS ""
    do_click
}

if {$started == 0} {  ;#  first time load code and define local variables
    set started 1
    
    variable JS ""
    
    proc do_redisplay {} {;}
    
    proc do_setPage { params } {   
    	
	set side [lindex [lindex $params 1] 1]	
	set asic [lindex [lindex $params 1] 2]
	set page [lindex [lindex $params 1] 3]
	set value [lindex [lindex $params 1] 4]
	
	for {set itrChannel 0} {$itrChannel < 128} {incr itrChannel} {
	    
	    if {$value >= 0} {
		
		WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + ($page << 8) + (128+$itrChannel) ] $value  
	    } elseif {$value < 0} {
		WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + ($page << 8) + (128+$itrChannel) ] [expr abs($value) + 127];
	    }
	    
	}
	
	return "Side$side Asic$asic Page$page offsets set to $value"
    }
    
    proc do_setRegister { params } { 
	
	set side     [lindex [lindex $params 1] 1]	
	set asic     [lindex [lindex $params 1] 2]
	set register [lindex [lindex $params 1] 3]
	set value    [lindex [lindex $params 1] 4]
	
	WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + $register] $value
	
	return "Side:$side Asic:$asic Register:$register Value:$value";
    }
    
    proc  do_click {}  {
	variable cgidata
	variable started
	variable LogFlag
	variable ShowLogFlag
	
	set cgidata [ncgi::nvlist]
	
	# InsertLog "cgidata= ([llength $cgidata]) $cgidata"
	
	if {[llength $cgidata] == 0} then {return}
	
	if {[llength $cgidata] < 2} then {
	    InsertLog "CGI data is too short: $cgidata"
	} else {
	    if {[lindex $cgidata 0] != "Widget"} then {
		InsertLog "Invalid CGI data: $cgidata"
	    } else {
		
		set w [first [lindex $cgidata 1]]
		
		switch -glob $w {
		    
		    RESET    { set started 0; }
		    SET_PAGE { InsertLog "[do_setPage $cgidata]" }
		    SET_REGISTER { InsertLog "[do_setRegister $cgidata]" }
		    
		    default {InsertLog "unexpected CGI data:  $cgidata"}
		}
	    }
        }
	do_redisplay
    }
    
}   ;# end of if {$started == 0}
