

#    Trigger setup  -   1x  opcodes

#    10   set window width
#    11   set window offset
#    12   set extra search margin
#    13   set reject margin
#    14   enable subtraction of trigger time
#    15   disable subtraction of trigger time

     proc do_trigopt {p vl} {

# InsertLog "do_trigopt $p"

#  p = 0;   set window width
#      1;   set window offset
#      2;   set extra search margin
#      3;   set reject margin
#      4;   enable subtraction of trigger time
#      5;   disable subtraction of trigger time

        switch $p {
           0  {do_set_opcode 0x1000 $vl}
           1  {do_set_opcode 0x1100 $vl}
           2  {do_set_opcode 0x1200 $vl}
           3  {do_set_opcode 0x1300 $vl}
           4  {do_cmd_opcode 0x1400}
           5  {do_cmd_opcode 0x1500}
        }
        redisplay_trig
    }

proc  redisplay_trig {} {
    variable TRIGOpt0
    variable TRIGOpt1
    variable TRIGOpt2
    variable TRIGOpt3
    variable TRIGOpt4
    variable TRIGOpt5
    
    set config [do_read_opcode 0x1600]
    set TRIGOpt0 [first $config]
    set TRIGOpt1 [second $config]
    set TRIGOpt2 [third $config]
    set TRIGOpt3 [fourth $config]

    set mode [fifth $config]
    set TRIGOpt4 $mode
    set TRIGOpt5 [expr ($mode + 1) & 1]

}


