
#    MIDAS Access Server  for Rsh service

package require MIDASDomainHandler    ;#  load default support procedures

global MIDAS_RshServer_Exists
set MIDAS_RshServer_Exists 1

global MIDAS_RshServer_Verbose
set MIDAS_RshServer_Verbose 0

global MIDAS_SOAPDomainHandler_Verbose
set MIDAS_SOAPDomainHandler_Verbose 0


# Use namespaces to isolate your methods
namespace eval urn:RshServer {

    proc Rsh {p} {
        global MIDAS_RshServer_Verbose
        if {$MIDAS_RshServer_Verbose} {puts "called method Rsh with parameter $p"}
        set z [catch {eval exec $p} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    # We have to publish the public methods...

     SOAP::export Rsh
}

# register this service with tclhttpd
puts [SOAP::Domain::register  -prefix  /RshServer -namespace urn:RshServer -uri urn:RshServer]


proc ::SOAP::Domain::MIDAS_SOAPDomainHandler_/RshServer {optsname sock args} {   \
    ::SOAP::Domain::MIDAS_SOAPDomainHandler_/DefaultAccessServer $optsname $sock $args}

package provide RshServer 1.0


