#  V812.defn.tcl


    set addressinfo [split $AddressData :]
    set A32Base [third $addressinfo]


   DefineRegister $Module xVME OutputWidthL        "-a $A32Base -w 32 -o 0x40 -p wo -d 16 -l 0 -b 0 -z x"
   DefineRegister $Module xVME OutputWidthH        "-a $A32Base -w 32 -o 0x42 -p wo -d 16 -l 0 -b 0 -z x"
   DefineRegister $Module xVME DeadTimeL           "-a $A32Base -w 32 -o 0x44 -p wo -d 16 -l 0 -b 0 -z x"
   DefineRegister $Module xVME DeadTimeH           "-a $A32Base -w 32 -o 0x46 -p wo -d 16 -l 0 -b 0 -z x"
   DefineRegister $Module xVME MajorityThreshold   "-a $A32Base -w 32 -o 0x48 -p wo -d 16 -l 0 -b 0 -z x"
   DefineRegister $Module xVME Enable              "-a $A32Base -w 32 -o 0x4a -p wo -d 16 -l 0 -b 0 -z x"
   DefineRegister $Module xVME Test                "-a $A32Base -w 32 -o 0x4c -p wo -d 16 -l 0 -b 0 -z x"

   for {set index 0} {$index < 16} {incr index} {
      DefineRegister $Module xVME Threshold$index     "-a $A32Base -w 32 -o [expr $index+$index] -p wo -d 16 -l 8 -b 0 -z d"
      DefineRegister $Module xVME Enable$index        "-a $A32Base -w 32 -o 0x4a -p wo -d 16 -l 1 -b $index -z d"
   }

   DefineRegister $Module xVME ModID#1         "-a $A32Base -w 32 -o 0xfe -p ro -d 16 -l 0 -b 0 -z x"
   DefineRegister $Module xVME ModID#2         "-a $A32Base -w 32 -o 0xfc -p ro -d 16 -l 0 -b 0 -z x"
   DefineRegister $Module xVME ModID#3         "-a $A32Base -w 32 -o 0xfa -p ro -d 16 -l 0 -b 0 -z x"

puts "Defined $Module"

